SystemOrganization addCategory: #'OmniST-Tests-Languages-Clojure'!
SystemOrganization addCategory: #'OmniST-Tests-Languages-ActiveObject'!
SystemOrganization addCategory: #'OmniST-Tests-Languages-CSPi'!

Object subclass: #OpAOPingObj
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-ActiveObject'!

!OpAOPingObj methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 19:59'!
printDomain
	Transcript log: omniDomain printString, '(', omniDomain hash asString, ')'.! !

CSPiProcess subclass: #CSPiPingPong
	instanceVariableNames: 'role strRole inputEnd receivingEnd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-CSPi'!

!CSPiPingPong class methodsFor: 'VM support' stamp: 'StefanMarr 7/29/2012 23:12'!
domainCustomizations ^ 16rFFF000! !

!CSPiPingPong class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 23:55'!
newWith: pingOrPong
	| proc |
	proc := self new.
	proc role: pingOrPong.
	proc adoptObject: pingOrPong.
	^ proc.! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/9/2012 23:16'!
ping: anInputEnd
	inputEnd := anInputEnd! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/9/2012 23:17'!
pong: aReceivingEnd
	receivingEnd := aReceivingEnd! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
receivePing
	| val |
	"ScriptConsole println: strRole, ': receivePing'."
	val := receivingEnd receive.
	
	"ScriptConsole println: strRole, ': receivePing completed.'."
	
	val = #ping ifFalse: [Error signal: 'Did not receive a ping but a ', val asString].! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
receivePong
	| val |
	"ScriptConsole println: strRole, ': receivePong.'."
	
	val := receivingEnd receive.
	
	"ScriptConsole println: strRole, ': receivePong completed.'."
	
	val = #pong ifFalse: [Error signal: 'Did not receive a pong but a ', val asString].! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 8/2/2012 13:12'!
role: pingOrPong
	role := pingOrPong.
	strRole := role asString.! !

!CSPiPingPong methodsFor: 'process runnable' stamp: 'StefanMarr 8/2/2012 13:06'!
run
	role == #ping
		ifTrue: [
			self sendPing.
			self receivePong.
		]
		ifFalse: [
			self receivePing.
			self sendPong.
		]! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
sendPing
	"ScriptConsole println: strRole, ': sendPing'."
	inputEnd send: #ping.
	"ScriptConsole println: strRole, ': sendPing done'."! !

!CSPiPingPong methodsFor: 'ping pong' stamp: 'StefanMarr 1/16/2013 13:16'!
sendPong
	"ScriptConsole println: strRole, ': sendPong'."
	inputEnd send: #pong.! !

OstObject subclass: #CSPiTestSubject
	instanceVariableNames: 'a'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-CSPi'!

!CSPiTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 21:54'!
a
	^ a! !

!CSPiTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 21:55'!
a: anA
	a := anA! !

OstObject subclass: #OActiveObjectTestSubject2
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-ActiveObject'!

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:42'!
a
	^ a! !

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:43'!
a: anA
	a := anA! !

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:42'!
b
	^ b! !

!OActiveObjectTestSubject2 methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:42'!
b: aB
	b := aB! !

OstObject subclass: #OcjAgentTestSuject
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-Clojure'!

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
a
	^ a! !

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
a: aVal
	a := aVal! !

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
b
	^ b! !

!OcjAgentTestSuject methodsFor: 'accessing' stamp: 'StefanMarr 1/6/2012 14:58'!
b: aVal
	b := aVal! !

!OcjAgentTestSuject methodsFor: 'initialization' stamp: 'StefanMarr 1/6/2012 14:58'!
initialize
	a := #a.
	b := #b.! !

OActiveObject subclass: #OActiveObjectTestSubject
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-ActiveObject'!

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
a
	^ a! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
a: anA
	a := anA! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
b
	^ b! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 15:53'!
b: aB
	b := aB! !

!OActiveObjectTestSubject methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:53'!
somePassiveObj
	^ OActiveObjectTestSubject2 new.! !

OActiveObject subclass: #OpAOPingPong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-ActiveObject'!

!OpAOPingPong class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/6/2011 00:47'!
example
	[ | ping |
		ping := OpAOPingPong new.
		ping ping. ] forkNamed: 'ping-pong-test'.! !

!OpAOPingPong methodsFor: 'as yet unclassified' stamp: 'StefanMarr 3/22/2012 14:46'!
ping
	<noReturnValue>
	Transcript log: 'ping'.
	Transcript log: 'PingPong domain: ', 
						(OstMirror domainOf: self) printString, '(', (OstMirror domainOf: self) hash asString, ')'.
	
	OpAOPingObj new printDomain.
	
	self pong.
	! !

!OpAOPingPong methodsFor: 'as yet unclassified' stamp: 'StefanMarr 11/5/2011 23:26'!
pong
	<noReturnValue>
	Transcript addEntry: 'pong'.! !

OstTestCase subclass: #CSPiChannelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-CSPi'!

!CSPiChannelTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 13:18'!
testConsecutiveSends
	| channel dummyDomain |
	dummyDomain := OstDomain new.
	channel := CSPiChannel in: dummyDomain out: dummyDomain.

	[ channel in send: 1. ] fork.
	self assert: 1 equals: channel out receive.
	
	[ channel in send: 2. ] fork.
	self assert: 2 equals: channel out receive.
	
	[ channel in send: 3. ] fork.
	self assert: 3 equals: channel out receive.
	! !

!CSPiChannelTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 13:18'!
testCreateChannel
	| channel dummyDomain |
	dummyDomain := OstDomain new.
	channel := CSPiChannel in: dummyDomain out: dummyDomain.

	[ channel in send: 1. ] fork. "Need to fork, is blocking operation"

	self assert: 1 equals: channel out receive.! !

OstTestCase subclass: #CSPiTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-CSPi'!

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 8/2/2012 12:49'!
testBasicSetup
	
	| p1 p2 c1 c2 |
	
	p1 := CSPiPingPong newWith: #ping.
	p2 := CSPiPingPong newWith: #pong.
	
	c1 := CSPiChannel in: p1 out: p2.
	c2 := CSPiChannel in: p2 out: p1.
	
	p1 ping: c1 in.
	p1 pong: c2 out.
	
	p2 ping: c2 in.
	p2 pong: c1 out.
	
	p1 start.
	p2 start.
	
	p1 join.
	p2 join.! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:59'!
testIsolationAssign
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj a: #foo] omni.
		] raise: Error.
! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:58'!
testIsolationRead
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj a] omni.
		] raise: Error.
! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:59'!
testIsolationReflectiveRead
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj instVarAt: 1] omni.
		] raise: Error.
! !

!CSPiTest methodsFor: 'tests' stamp: 'StefanMarr 1/9/2012 21:59'!
testIsolationReflectiveWrite
	
	| proc obj |
	obj := CSPiTestSubject new.
	proc := CSPiPingPong newWith: obj.

	"Now the obj should be adopted"
	self should: [
		[obj instVarAt: 1 put: #foo] omni.
		] raise: Error.
! !

OstTestCase subclass: #OActiveObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-ActiveObject'!

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:49'!
testActiveObjectReturnsPromise
	| ao result |
	ao := OActiveObjectTestSubject new.

	self assert: nil equals: ao a.
	
	result := [ao a: #foo] omni.
	self assert: (result isKindOf: OPromise).
	
	result := [ao a] omni.
	self assert: (result isKindOf: OPromise).
	
	result := [ao b: #foo] omni.
	self assert: (result isKindOf: OPromise).! !

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 18:30'!
testCheckAsyncExecution
	| ao |
	ao := OActiveObjectTestSubject new.

	self assert: nil equals: ao a.
	
	"Foo should not be executed imediatly."
	[| p |
	 p := [ao a: #foo] omni.
	 self assert: (p isKindOf: OPromise).
	 self assert: nil equals: ao a.
	] valueUnpreemptively.

	Processor yield. "This works only since we assume round-robin scheduling"
	Processor yield.
	
	self assert: #foo equals: ao a.! !

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 18:28'!
testCheckAsyncExecutionOfReflection
	| ao idxA |
	ao := OActiveObjectTestSubject new.
	idxA := OActiveObjectTestSubject instVarIndexFor: #a.
	
	
	self assert: nil equals: ao a.
	
	"Foo should not be executed imediatly."
	[[ao instVarNamed: #a put: #foo] omni.
	 self assert: nil equals: ao a.
	] valueUnpreemptively.

	Processor yield. "This works only since we assume round-robin scheduling"
	(Delay forSeconds: 1) wait.
	
	self assert: #foo equals: ao a.! !

!OActiveObjectTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/9/2012 16:53'!
testCheckSyncExecutionOnPassiveObjects
	| ao passive result |
	ao := OActiveObjectTestSubject new.
	
	[ passive := ao somePassiveObj read] omni.

	self assert: nil equals: passive a.
	
	"Is directly executed without sending an async message."
	[[ passive a: #foo ] omni.
	 self assert: #foo equals: passive a.
	] valueUnpreemptively.
! !

!CjAgentTest methodsFor: '*OmniST-Tests-Languages-Clojure-running' stamp: 'StefanMarr 7/31/2012 23:17'!
tearDown
	(Smalltalk classNamed: #ONOMirror)
		ifNotNilDo: [:c | c reenableScheduling].
	^ super tearDown! !

CjAgentTest subclass: #OcjAgentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-Clojure'!

!OcjAgentTest class methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 13:01'!
shouldInheritSelectors
	^ true! !

!OcjAgentTest methodsFor: 'configuration' stamp: 'StefanMarr 1/5/2012 14:26'!
agentNew
	^ OcjAgent new! !

!OcjAgentTest methodsFor: 'configuration' stamp: 'StefanMarr 1/5/2012 14:26'!
agentNew: initialState
	^ OcjAgent new: initialState! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 12:48'!
testAwaitOmni
	| agent |
	agent := self agentNew.

	[ agent send: [:i | #noop].
	  agent send: [:i | #noop].
	  agent send: [:i | #noop].
	  agent send: [:i | #last].
	
	  agent await. ] omni. "The agent is its own domain, and we access it from another domain."
	
	self assert: #last equals: agent read.
	! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 12:49'!
testReadOmni
	| agent result |
	
	"without initial value"
	agent := self agentNew.
	self assert: nil    equals: [ agent read ] omni.
	
	"with initial value"
	agent := self agentNew: #first.
	self assert: #first equals: [ agent read ] omni.
	
	result := [
		agent send: [:i | #foo].
		agent await.
		agent read ] omni.
	self assert: #foo equals: result.! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 14:35'!
testSendOmni
	| agent result |
	agent := self agentNew: 0.
	
	self assert: 0 equals: agent read.

	result := [
		agent send: [:old | old + 1].
		agent await.
		agent read. ] omni.
	
	self assert: 1 equals: result.
	
	result := [
		agent send: [:old | old + 20].
		agent send: [:old | old + 21].
		agent await.
		agent read ] omni.
	
	self assert: 42 equals: result.
	! !

!OcjAgentTest methodsFor: 'tests' stamp: 'StefanMarr 1/6/2012 12:58'!
testSendWithOmni
	| agent incFn result |
	agent := self agentNew: 0.
	
	result := [
		incFn := [:old :inc | old + inc]. "make sure this block is omnified"
		agent read. ] omni.
	
	self assert: 0 equals: result.
	
	result := [
		agent send: incFn with: 1.
		agent await.
		agent read ] omni.
	
	self assert: 1 equals: result.
	
	result := [
		agent send: incFn with: 20.
		agent send: incFn with: 21.
		agent await.
		agent read ] omni.
	
	self assert: 42 equals: result.! !

OcjAgentTest subclass: #OcjAgentWithImmutabilityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OmniST-Tests-Languages-Clojure'!

!OcjAgentWithImmutabilityTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 15:22'!
testImmutabilityOk
	| agent a b |
	agent := OcjAgentWithImmutability new.
	
	[ | r |
	  agent send: [:o| OcjAgentTestSuject new.].
	  agent await.
	  r := agent read.
	  a := r a.
	  b := r b. ] omni.

	self assert: #a equals: a.
	self assert: #b equals: b.! !

!OcjAgentWithImmutabilityTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 15:30'!
testImmutabilityOkWithUseInOmniDomain
	| agent a b |
	agent := OcjAgentWithImmutability new.
	
	[ | r |
	  agent send: [:o| OcjAgentTestSuject new.].
	  agent await.
	  r := agent read.
	  a := r a.
	  b := r b. ] omni.

	self assert: #a equals: a.
	self assert: #b equals: b.
	
	[ agent send: [:o | | n |
							n := OcjAgentTestSuject new.
							n a: o.
							n].
	  agent await.
	  a := agent read] omni.

	self assert: #a equals: a a a.! !

!OcjAgentWithImmutabilityTest methodsFor: 'as yet unclassified' stamp: 'StefanMarr 1/6/2012 15:29'!
testImmutabilityViolation
	| agent a b |
	agent := OcjAgentWithImmutability new.
	
	[ agent send: [:o| OcjAgentTestSuject new.] ] omni.
	
	agent await.
	a := agent read.
	
	self should: [ [ a a: #foo.] omni.]
	     raise:  Error.

	self assert: #a equals: a a.! !
